---------------------------------------------------------------------------
book.title = 'Crossing the river'
book.author = 'Enrico Colombini'
book.copyright = 'Copyright (C) 2009, 2014 Enrico Colombini - CC BY-SA 4.0'

book.firstPage = 'start'

-- license: Attribution-ShareAlike 4.0 International
-- http://creativecommons.org/licenses/by-sa/4.0/

--=======================================================================--
$section [At home]
--=======================================================================--

---------------------------------------------------------------------------
# start

P"I have to bring a <b>wolf</b>, a <b>goat</b> and a <b>very large cabbage</b> to the market."
P"My destination is across the river, but my boat is so tiny that I can only take aboard one thing at a time."
P"Please help me carry them all safely to the other side."

v.wolf = 1 -- river side (1=near, 2=far, 3=boat)
v.goat = 1
v.cabbage = 1

Choice("No problem", 'nearside')
  
    
--=======================================================================--
$section [On the river]
--=======================================================================--

---------------------------------------------------------------------------
# nearside

P"This is the river bank nearest to home; I have to bring all three items undamaged to the other bank."
P""

if v.wolf == 1 then T"Here is the wolf I have to ferry across the river.<br>" end
if v.goat == 1 then T"Here is the goat I have to ferry across the river.<br>" end
if v.cabbage == 1 then T"Here is the cabbage I have to ferry across the river.<br>" end

if v.wolf == 1 then Choice("Take the wolf", 'river', F{v.wolf = 3} ) end
if v.goat == 1 then Choice("Take the goat", 'river', F{v.goat = 3} ) end
if v.cabbage == 1 then Choice("Take the cabbage", 'river', F{v.cabbage = 3} ) end
-- in any case
Choice("Cross the river alone", 'river')

---------------------------------------------------------------------------
# river

P"I am in the middle of the river; I have to keep rowing to prevent the current from dragging the boat downriver."

local load = nil
if v.wolf == 3 then
    load = 'wolf'
    P"The wolf fears the water and stays curled up on the boat's bottom, whining faintly."
elseif v.goat == 3 then
    load = 'goat'
    P"The goat is idly nibbling at the hem of my shirt."
elseif v.cabbage == 3 then
    load = 'cabbage'
    P"The cabbage is rolling back and forth between the sides of the boat."
end

if v.wolf == v.goat then
    P"I hear the desperate bleats of the goat being <b>devoured by the wolf</b>."
    Choice("Oops...", 'lost', F{v={}})
elseif v.goat == v.cabbage then
    P"I hear the happy bleats of the goat which is <b>eating the cabbage</b>."
    Choice("Oops...", 'lost', F{v={}})
else
    Choice("Land on the side closest to home", 'nearside', F{if load then v[load] = 1 end} )
    Choice("Land on the side closest to the market", 'farside', F{if load then v[load] = 2 end} )
end

---------------------------------------------------------------------------
# farside

P"This is the river bank nearest to the market. "
P""

if v.wolf == 2 then T"I brought the wolf here.<br>" end
if v.goat == 2 then T"I brought the goat here.<br>" end
if v.cabbage == 2 then T"I brought the cabbage here.<br>" end

if v.wolf == 2 then Choice("Ferry back the wolf", 'river', F{v.wolf = 3} ) end
if v.goat == 2 then Choice("Ferry back the goat", 'river', F{v.goat = 3} ) end
if v.cabbage == 2 then Choice("Ferry back the cabbage", 'river', F{v.cabbage = 3} ) end
-- in any case
Choice("Cross the river alone", 'river')

if v.wolf == 2 and v.goat == 2 and v.cabbage == 2 then
    Choice("Go to the market", 'won')
end


--=======================================================================--
$section [Well done!]
--=======================================================================--

---------------------------------------------------------------------------
# won

P"Thanks to your help, I was able to safely carry all my stuff across the river: now I can sell it and feed my family."
P"<b>You've been really great!</b><br>"
P"<center><b>The end</b></center><br>"

Choice("Play again", 'start', F{v={}} )

--=======================================================================--
$section [Disaster!]
--=======================================================================--

---------------------------------------------------------------------------
# lost

P"What sort of advice did you give me? Because of you <b>I'm ruined!</b>"

Choice("Try again", 'start', F{v={}} )

---------------------------------------------------------------------------
